#!/usr/bin/perl
#
# Sensor for gathering RAID status data for Zabbix via
# arrayprobe.
# Copyright (c) 2008 Jakov Sosic
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# Changes and Modifications
# * Tue Mar 17 18:02:15 CET 2009
# 	- fixed alarms
# * Thu May 15 03:40:39 CEST 2008       
#       - script created
#

use strict;

# zabbix path
my $zabbix_sender="/usr/bin/zabbix_sender";
my $zabbix_confd="/etc/zabbix/zabbix_agentd.conf";
my $send_file="/var/tmp/zabbixSenderFilePostgreSQL";
my $zabbix_send_command="$zabbix_sender -c $zabbix_confd -i $send_file";
my $inputString = '';
my $hostname = `/bin/hostname -f`;
chomp($hostname);

my $arrayp="/usr/bin/arrayprobe";
my $zabbix_send_command="$zabbix_sender -c $zabbix_confd";
#my $conf="/home/zabbix/bin/ccissvol_smartmon_sensor_conf";
#my $conf="/usr/lib/zabbix-agent/ccissvol_smartmon_sensor_conf";

# signal handling
$SIG{'ALRM'} = sub {
	local $SIG{TERM} = 'IGNORE';
	kill TERM => -$$;
	print "0\n";
	exit(-1);
};

local $SIG{TERM} = sub {
	local $SIG{TERM} = 'IGNORE';
	kill TERM => -$$;
	print "0\n";
	exit(-1);
};

alarm 25;

#open FILE, $conf;
#my $disk=<FILE>;
#chomp $disk;
#print $disk;
my $cmd = "sudo $arrayp -f /dev/cciss/c0d0";
my $server_status = qx($cmd);

# get information from status output
my($health);
$health = $1 if ($server_status =~ /^(\S+)\s+.+/);

# check health
if($health eq "OK"){$health=1;}
else {$health=0;}
#print "kita".$health."\n";

# finally, send the data
if ( qx($zabbix_send_command) =~ /Failed(:)? 0/i ) {
   unlink ($send_file) or die("Can not remove file $send_file!");
   print("1\n");
   exit(0);
} else {
   unlink ($send_file) or die("Can not remove file $send_file!");
   print("0\n");
   exit(-1);
}
#EOF
